# _*_  coding:utf-8  _*_
import tkinter as tk
import os,sys,cv2,threading,time
import threading
import numpy as np
import tkinter.messagebox
import tkinter.filedialog as tkFileDialog
from tkinter.filedialog import askopenfilename,asksaveasfilename
from PIL import Image, ImageTk,ImageDraw,ImageFont
import face_recognition as fr


def resource_path(relative_path):
    base_path = sys._MEIPASS if  getattr(sys, 'frozen', False) else os.path.abspath(".")
    return os.path.join(base_path, relative_path)
def get_basename(path):
    return os.path.splitext(os.path.basename(path))[0]
def cv2AddChineseText(img, text, position, textColor=(0, 255, 0), textSize=30):
    if (isinstance(img, np.ndarray)):  # 判断是否OpenCV图片类型
        img = Image.fromarray(cv2.cvtColor(img, cv2.COLOR_BGR2RGB))
    # 创建一个可以在给定图像上绘图的对象
    draw = ImageDraw.Draw(img)
    # 字体的格式
    fontStyle = ImageFont.truetype(
        "simsun.ttc", textSize, encoding="utf-8")
    # 绘制文本
    draw.text(position, text, textColor, font=fontStyle)
    # 转换回OpenCV格式
    return cv2.cvtColor(np.asarray(img), cv2.COLOR_RGB2BGR)
    #return img
class Data():
    def __init__(self):
        self.groupPhoto = resource_path(os.path.join("image", "default.png"))     #待检测照片
        self.known_names = []                         #训练后的名字列表
        self.known_name_encodings = []                #训练后的图像信息列表
                     
class App():
    def  __init__(self,root):
      self.root = root
      self.data = Data()
      self.w, self.h = 780, 435
      self.g_w,self.g_h = 450,300        #合影框大小
      self.p_w,self.p_h = 200,300        #待检测框大小
      self.initwindow()
    def initwindow(self):
        
        self.root.title('人脸识别与检测     ——程序设计：舒大荣')
        self.root.resizable(width=False, height=False)
        screenwidth = self.root.winfo_screenwidth()
        screenheight = self.root.winfo_screenheight()
        x, y = (screenwidth - self.w) / 2, (screenheight - self.h) / 2
        self.root.geometry("%dx%d+%d+%d" % (self.w, self.h, x, y))
        self.root.iconbitmap(resource_path(os.path.join("image", "main.ico")))
        self.root.config(fg=None)
        self.capture = None   #摄像头
        self._flag = threading.Event()          #创建线程暂停标志
        tk.Frame(self.root,height=30).pack()
        topfrm = tk.Frame(self.root,bd=2,height=300)
        botfrm = tk.Frame(self.root,bd=2,height=40)
        linefrm = tk.Frame(self.root,height=2,relief='groove',bd=1)
        
        t_l_frm = tk.Frame(topfrm,bd=2)
        t_r_frm = tk.Frame(topfrm)


        t_l_frm.pack(side="left",fill="y",padx=10,anchor='s')
        t_r_frm.pack(side="right",fill="y",padx=10)
        
        self.l_imageBox = tk.Canvas(t_l_frm,bg="#FFFFFF",width=self.g_w,height=self.g_h)#绘制画布
        
        self.r_imageBox= tk.LabelFrame(t_r_frm,text='检测结果',width=self.p_w,height=self.p_h)
        self.dispimg(self.data.groupPhoto,True)     #加载默认合影图像

        self.l_imageBox.pack(side='top',pady=5)
        self.r_imageBox.pack(side='top',pady=5)
        self.r_imageBox.pack_propagate(0)
        l_Btnfrm=tk.Frame(t_l_frm)
        l_Btnfrm.pack(side='bottom',fill='x')
        r_Btnfrm=tk.Frame(t_r_frm)
        r_Btnfrm.pack(side='bottom',fill='x')
        
        self.msgText =  tk.Label(l_Btnfrm, width=20,anchor='w',fg='#F00',font=('微软雅黑', 10, 'bold'))
        self.msgText.pack(side='left')
        self.groupBtn = tk.Button(l_Btnfrm, text='本地上传',relief='groove',command=self.uploadGimage)
        self.groupBtn.pack(side='right', ipadx=10,padx=5)
        self.VideoBtn = tk.Button(l_Btnfrm, text='开启摄像头',relief='groove',command=self.startVideoGimage)
        self.VideoBtn.pack(side='right', ipadx=10,padx=5)

        tk.Label(l_Btnfrm,text='待识别人脸图片：').pack(side='right')

        self.checklst = tk.Listbox(self.r_imageBox,height=15,relief='flat')
        self.checklst.pack(padx=5,pady=5,fill='x')
        yscrollbar = tk.Scrollbar(self.r_imageBox,orient='vertical', command=self.checklst.yview)
        yscrollbar.pack(side='right', fill='y')
        self.checklst.config(yscrollcommand=yscrollbar.set)
        
        
        
        self.trainBtn = tk.Button(botfrm, text='上传训练集照片&训练',relief='groove',command=self.uploadTrain)
        self.clearBtn = tk.Button(botfrm, text='删除训练结果',relief='groove',command=self.clearTrain)
        self.findBtn = tk.Button(botfrm, text='识别人脸',relief='groove',bg='#0ff',command=self.recognition)
        self.helpBtn = tk.Button(botfrm, text='操作说明',relief='groove',command=self.help)
        self.trainBtn.pack(side='left', padx=10,ipadx=50)
        self.clearBtn.pack(side='left', padx=10,ipadx=50)
        self.helpBtn.pack(side='left', padx=10,ipadx=30)
        self.findBtn.pack(side='right', padx=10,ipadx=30)
        
        
        ########################################################
        topfrm.pack(fill='x',padx=30,side="top")
        botfrm.pack(fill='x',pady=5,side="bottom")
        linefrm.pack(fill='x',side="bottom")
    def uploadGimage(self):
        #上传合影照片
        filename = askopenfilename(filetypes=[('图像文件', '*.jpg;*.png;*.gif'), ('All Files', '*')])
        if filename == "": return
        self.data.groupPhoto = filename
        self.dispimg(filename,True)  #刷新合影框中图像
    def startVideoGimage(self):
        t=threading.Thread(target=self.OpenVideo)
        t.daemon
        t.start()
    def OpenVideo(self):
        if not self.capture:
            self.capture=cv2.VideoCapture(0+cv2.CAP_DSHOW)
        if not self.capture.isOpened():
            self.msgText.config(text="提示：打开摄像头失败。")
            return
        self.VideoBtn.config(text='关闭摄像头')
        self.VideoBtn.config(command=self.closeVideoGimage)
        
        while self.capture and self.capture.isOpened():
            ret, frame = self.capture.read()   #从摄像头读取帧图像  
            #frame = cv2.flip(frame, 1)        #翻转 0:上下颠倒 ⼤于0⽔平颠倒
            cv2image = cv2.cvtColor(frame, cv2.COLOR_BGR2RGBA)
            img = Image.fromarray(cv2image)
            time.sleep(0.1)
            self.dispimg(img,False)
    def closeVideoGimage(self):
        if self.capture and self.capture.isOpened():
            ret, frame = self.capture.read()   #从摄像头读取帧图像
            cv2image = cv2.cvtColor(frame, cv2.COLOR_BGR2RGBA)
            self.data.groupPhoto = cv2image
          
            self.VideoBtn.config(text='打开摄像头')
            self.VideoBtn.config(command=self.startVideoGimage)
            self.capture.release()
            self.capture = None
    def dispimg(self,imgName,isOpen=True):
        if isOpen:
            img = Image.open(imgName)
        else:
            img = imgName
        w = self.g_w
        h = self.g_h
        scale = w / img.size[0]  if img.size[0]>img.size[1] else h / img.size[1] # 缩放比例
        new_width, new_height = int(img.size[0] * scale), int(img.size[1] * scale)
        
        file = img.resize((new_width, new_height))  
        self.disp_img = ImageTk.PhotoImage(file)
        self.l_imageBox.create_image(w/2, h/2,anchor="center",image=self.disp_img)
    def uploadTrain(self):
        images = tkFileDialog.askopenfilenames(parent=root,title='Choose a file')
        if images:
            #############################
            self.U = threading.Thread(target=self.startTrain,args=(images,))
            self._flag.set()  #线程事件标志为True
            self.U.daemon = True  #把t设置为守护线程，随主线程的结束而结束
            self.U.start()  #开始训练
            self.transbtnstate(False)
            #############################
        
    def startTrain(self,img):
        self.msgText.config(text="训练中……")
                
        for _ in img:
            image = fr.load_image_file( _ )
            ecode = fr.face_encodings(image)
            if ecode:
                encoding = fr.face_encodings(image)[0]
            else:
                 continue
            self.data.known_name_encodings.append(encoding)
            
            self.data.known_names.append(os.path.splitext(os.path.basename(_))[0].capitalize())
        self.msgText.config(text="训练完成！")
        
        self.transbtnstate(True)
    def clearTrain(self):
        self.data.known_names.clear() 
        self.data.known_name_encodings.clear()
        self.msgText.config(text="提示：训练结果已删除。")
       
        
    def recognition(self):
        #人脸识别
        
        #############################
        self.t = threading.Thread(target=self.startRecogition)
        self._flag.set()  #线程事件标志为True
        self.t.daemon = True  #把t设置为守护线程，随主线程的结束而结束
        self.t.start()  #开始识别
        self.transbtnstate(False)
        #############################
    def startRecogition(self):
        self._flag.wait()   #阻塞线程,核心语句
        self.msgText.config(text="正在分析……")
        
        self.closeVideoGimage()
        self.checklst.delete(0,self.checklst.size())

        if isinstance(self.data.groupPhoto,str):
            image = cv2.imdecode(np.fromfile(self.data.groupPhoto,dtype=np.uint8),cv2.IMREAD_COLOR)
        else:
            image =   cv2.cvtColor(np.asarray(self.data.groupPhoto), cv2.COLOR_RGB2BGR)
        face_locations = fr.face_locations(image)
        face_encodings = fr.face_encodings(image, face_locations)  #合影照片中的人脸信息
        
        if not face_locations:
            self.msgText.config(text="提示：图像中没有人。")
            self.transbtnstate(True)
            return
        
       
        if not self.data.known_names:
            self.checklst.insert('end', "不认识照片上的人")
        else:
            s = 0
            for (top, right, bottom, left), face_encoding in zip(face_locations, face_encodings):
                matches = fr.compare_faces(self.data.known_name_encodings, face_encoding,0.5)
                name = ""
                face_distances = fr.face_distance(self.data.known_name_encodings, face_encoding)
                best_match = np.argmin(face_distances)

                if matches[best_match]:
                    name =self.data.known_names[best_match]
                    self.checklst.insert('end', name)
                    cv2.rectangle(image, (left, top), (right, bottom), (0, 0, 255), 2)

                    s+=1
            if not s:
                self.checklst.insert('end', "不认识照片上的人")
            else:    
                image = Image.fromarray(cv2.cvtColor(image, cv2.COLOR_BGR2RGB))
                self.dispimg(image,False)
        self.msgText.config(text="识别完成！")
        self.transbtnstate(True)
    def transbtnstate(self,state):
        """切换按钮状态"""
        if state:
            self.findBtn.config(state='normal')        #启用识别人脸按钮
            self.trainBtn.config(state='normal')     
            self.clearBtn.config(state='normal')     
        else:
            self.findBtn.config(state='disabled')      #禁用识别人脸按钮
            self.trainBtn.config(state='disabled')       
            self.clearBtn.config(state='disabled')       
    def help(self):
        model = tk.Toplevel(root)
        model.title('使用说明')
        screenwidth = root.winfo_screenwidth()
        screenheight = root.winfo_screenheight()
        w, h = 370, 400
        x, y = (screenwidth - w) / 2, (screenheight - h) / 2
        model.geometry("%dx%d+%d+%d" % (w, h, x, y))
        model.iconbitmap(resource_path(os.path.join("image", "help.ico")))
        model.transient(root)           #不在任务栏上显示窗口图标，父窗口被图标化或最小化将被隐藏
        model.grab_set()                #模态对话框
        ttk.Button(model, text='关闭', command=lambda: model.destroy()).pack(side='bottom', pady=10)
        ttk.Separator(model,orient='horizontal').pack(side='bottom',fill='x',padx=5)
        frm = tk.Frame(model,bg='#fff')
        frm.pack(expand=True,fill='both',padx=10,pady=10)
        readme ="1.本程序是对开源人脸识别项目face_recognition的简单测试，可以用于识别图片中的人是谁。"
        readme +="\n\n2.当单击“识别人脸”时，程序会识别“待识别人脸图片”中每个人的名字，反馈到“检测结果”框中，并在相应人脸上画出红框。"
        readme += "\n\n3.当训练图片上有多个人脸时，只训练第一个人的人脸信息。可以使用多张图片进行多次训练。"
        readme += "\n\n4.单击“删除训练结果”将删除程序本次运行以来所有训练的人脸信息。"
        
        tk.Message(frm,text=readme,bg='#fff',justify='left',font=('微软雅黑',12,''),width=320,anchor='w').pack(fill='x',padx=10,pady=10)

    def is_closewindow(self):
       ans = tk.messagebox.askquestion(title="退出程序",message="是否退出程序？")
       if ans == 'yes':
           root.destroy()
   
root = tk.Tk() 
app = App(root)
root.mainloop()
